package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import io.accumulatenetwork.sdk.protocol.RawJson;
import io.accumulatenetwork.sdk.protocol.TransactionBody;
import io.accumulatenetwork.sdk.support.Marshaller;
import io.accumulatenetwork.sdk.support.serializers.HexDeserializer;
import io.accumulatenetwork.sdk.support.serializers.HexSerializer;
// UnionType: TransactionType
// UnionValue: SendTokens

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("SendTokens")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class SendTokens implements TransactionBody {
	public final TransactionType type = TransactionType.SEND_TOKENS;
	private byte[] hash;
	private RawJson meta;
	private TokenRecipient[] to;

    //
	@JsonDeserialize(using = HexDeserializer.class)
	public byte[] getHash() {
	    return hash;
	}
	@JsonSerialize(using = HexSerializer.class)
	public void setHash(final byte[] value) {
	    this.hash = value;
	}

	public SendTokens hash(final byte[] value) {
	    setHash(value);
	    return this;
	}
	public SendTokens hash(final String value) {
		try {
			setHash(io.accumulatenetwork.sdk.commons.codec.binary.Hex.decodeHex(value));
		} catch (io.accumulatenetwork.sdk.commons.codec.DecoderException e) {
			throw new RuntimeException(e);
		}
	    return this;
	}
	public RawJson getMeta() {
	    return meta;
	}
	public void setMeta(final RawJson value) {
	    this.meta = value;
	}

	public SendTokens meta(final RawJson value) {
	    setMeta(value);
	    return this;
	}
	public TokenRecipient[] getTo() {
	    return to;
	}
	public void setTo(final TokenRecipient[] value) {
	    this.to = value;
	}

	public SendTokens to(final TokenRecipient[] value) {
	    setTo(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.hash == null || this.hash.length == 0)) {
            marshaller.writeHash(2, this.hash);
        }
        if (!(this.meta == null || this.meta.length == 0)) {
            marshaller.writeRawJson(3, this.meta);
        }
        if (!(this.to == null)) {
            marshaller.writeValue(4, to);
        }
        return marshaller.array();
    }
}
